<?php

namespace Meibuyu\Rpc\Service\Interfaces\Flow;

interface FlowServiceInterface
{

    /**
     * Notes: 创建审批
     * User: carlos
     * DateTime: 2022/11/9 14:16
     * @param $params
     * [
     *      'code' => '', //来源单号
     *      'flow_code' => '',//审批code
     *      'user_id' => '',//申请人id
     * ]
     * @throws \Exception
     */
    public function createApproval($params);

    /**
     * Notes: 审批
     * User: carlos
     * DateTime: 2022/11/10 9:16
     * @param $params
     * [
     *      'code' => '', //来源单号
     *      'user_id' => '', //审批人
     *      'line_code' => '',//审批节点编码
     *      'approval' => '', // 审批结果 通过、拒绝 pass  reject
     *      'params' => '',//审批参数
     * ]
     */
    public function approval($params);

    /**
     * Notes: 获取审批详情
     * User: carlos
     * DateTime: 2022/11/14 14:10
     * @param $params
     */
    public function getApprovalDetail($params);

    /**
     * Notes: 取消审批
     * User: carlos
     * DateTime: 2022/11/24 18:16
     * @param $params
     * @return mixed
     */
    public function cancelApproval($params);

    /**
     * Notes: 获取审批用户、进度
     * User: carlos
     * DateTime: 2023/1/10 18:02
     */
    public function getApprovalUserProgress($flowCode, $codeArr);

    /**
     * Notes: 获取用户审批中的codes
     * User: carlos
     * DateTime: 2023/1/13 16:56
     * @param $user_id
     * @param $flowCode
     */
    public function getUserApprovalCodes($user_id, $flowCode);

    /**
     * Notes: 获取审批用户列表
     * User: carlos
     * DateTime: 2023/1/30 14:11
     */
    public function getApprovalUserList($flowCode);
}